#!/usr/bin/env python
#
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

import os, sys, codecs

def main():
  delimiter = sys.argv[1]
  fileNames = sys.argv[2:]
  
  files = []
  
  for fileName in fileNames:
    files.append(codecs.open(fileName, "r", "utf-8"))
  
  ongoing = True
  
  while (ongoing):
    lines = []
    for file in files:
      line = file.readline()
      if (line == ""):
        ongoing = False
        break
      lines.append(line.rstrip())
    if (ongoing):
      print delimiter.join(lines)  

    
if __name__ == "__main__":
    main()
